/*
Copyright (C) 2018 - 2019 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
// page shuukei

var psk_kenzan_alert_mada = true

function psk(){
  var s = "<button onClick=pt()>戻る</button>" +
"<button onClick=ps()>設定</button><br>"
  var d1 = data.get()
  d1.sort()
  var ym_s = "" // 年月 
  var d_s = "" // 日
  var ta = [ 0, 0, 0, 0, 0, 0, 0 ] // 0:年(int) 1:月(int) 2:日数 3:通常 4:経費 5:前払 6:酒
  var sa = [], i
  for(i = 0; i < d1.length; i++){
    var a = d1[i].split(",")
// 0    1  2  3  4  5  6  7   8        9    10    11    12    13   14?          15?
// 2019,02,09,土,14,46,30,130,集計区分,金額,区分1,区分2,区分3,メモ,新規登録日時,key
    if(ta[0] == 0){
      ta[0] = parseInt(a[0])
      ta[1] = parseInt(a[1])
    }
    var ym = a[0] + a[1], v = parseInt(a[9])
    if(ym != ym_s && ym_s != ""){
      sa.push(psk_sub(ta) )
      ta[0] = parseInt(a[0])
      ta[1] = parseInt(a[1])
    }
    if(a[8] == pt_sk_sa[0]){ // 通常
      ta[3] += v
      if(a[12] == "酒")
        ta[6] += v
    }else if(a[8] == pt_sk_sa[3]){ // 経費
      ta[4] += v
    }else if(a[8] == pt_sk_sa[2]){ // 前払
      ta[5] += v
    }
    if(d_s != a[2])
      ta[2]++
    ym_s = ym
    d_s = a[2]
  }
  sa.push(psk_sub(ta, true) )
  sa.reverse()
  s +=
"集計結果(千円単位)<br>" +
"<table border=1>" +
"<tr><td>月</td><td>月差</td><td>通常</td><td>経費</td>" +
"<td>前払</td><td>酒</td><td>総差</td><td>年</td><td>日数</td><td>予算</td></tr>" +
sa.join("")
  s += "</table>"
  naiyou.innerHTML = s
}

function psk_sub(ta, not_put = false){
  var key = "" + ta[0] + "," + ta[1]
  var sa = data.get_shuukei(key) // 今月の集計。
  if(not_put == false){ // 今月の最終日の時。
    if(sa == null){ // 今月の集計が無い時。
      data.put_shuukei(key, [ta[2], ta[3], ta[4], ta[5], ta[6] ]) // 2:日数 3:通常 4:経費 5:前払 6:酒
    }else{ // 検算。今月の集計が有る時。
      if(ta[2] == sa[0] && // 日数。
         ta[3] == sa[1] && // 通常。
         ta[4] == sa[2] && // 経費。
         ta[5] == sa[3] && // 前払。
         ta[6] == sa[4] ){ // 酒。
        // 何もしない。検算okなので。
      }else{ // 検算ngの時。つまり、前半のデータが削除された時。
        if(psk_kenzan_alert_mada){
          psk_kenzan_alert_mada = false
          alert("集計結果(前)と過去に登録された集計データ(後)が違いました。\n" +
                "日数 " + ta[2] + " " + sa[0] + "\n" +
                "通常 " + ta[3] + " " + sa[1] + "\n" +
                "経費 " + ta[4] + " " + sa[2] + "\n" +
                "前払 " + ta[5] + " " + sa[3] + "\n" +
                "酒　 " + ta[6] + " " + sa[4] + "\n" +
                "修正しましたので、問題は有りません。")
        }
        ta[2] = sa[0] // 日数。
        ta[3] = sa[1] // 通常。
        ta[4] = sa[2] // 経費。
        ta[5] = sa[3] // 前払。
        ta[6] = sa[4] // 酒。
      }
    }
  }
  sa = data.get_shuukei(key, true) // 前月の集計。
  if(sa == null) // 前月の集計が無い時。
    sa = [0, 0, 0, 0, 0] // 0:日数 1:通常 2:経費 3:前払 4:酒
  var yosan_hi = Math.floor(va_for_settei[0] *10000/365)
  var r =
"<tr><td>" + ta[1] + // 月
"</td><td class=a>" + Math.floor( ( (ta[2] - sa[0]) * yosan_hi - (ta[3] - sa[1]) ) /1000) + // 月差
"</td><td class=a>" + Math.floor( (ta[3] - sa[1]) /1000) + // 通常(月)
"</td><td class=a>" + Math.floor( (ta[4] - sa[2]) *100 / (ta[3] - sa[1]) ) + "%" + // 経費(月)
"</td><td class=a>" + Math.floor( (ta[5] - sa[3]) *100 / (ta[3] - sa[1]) ) + "%" + // 前払(月)
"</td><td class=a>" + Math.floor( (ta[6] - sa[4]) *100 / (ta[3] - sa[1]) ) + "%" + // 酒(月)
"</td><td class=a>" + Math.floor( (ta[2] * yosan_hi - ta[3]) /1000) + // 総差
"</td><td>" + ta[0] + // 年
"</td><td class=a>" + (ta[2] - sa[0]) + // 日数(月)
"</td><td class=a>" + Math.floor( (ta[2] - sa[0]) * yosan_hi /1000) + // 予算(月)
"</td></tr>"
  return r
}
